/*
	AsciiToHetroCmd.cc

	Will Eighteen, 2006: will@opaline.demon.co.uk

	Warning: developed under Linux on Intel PC: 'intSize' may need
	changing in a different environment, as might num[].
*/

#include "AsciiToHetroCmd.h"
#include <FileAccess.h>
#include "wave/waveclass.h"
#include <MessageDialogManager.h>


AsciiToHetroCmd::AsciiToHetroCmd ( char *name, int active, char *txtFile, char *floatFile ) : BreakCmd ( name, active )
{
	strncpy ( _srcFile, txtFile, BUFSIZE );
	_srcFile [ sizeof ( _srcFile ) - 1 ] = 0;
	strncpy ( _dstFile, floatFile, BUFSIZE );
	_dstFile [ sizeof ( _dstFile ) - 1 ] = 0;
	_once = 0;
	_percentDone = 0;
	_error = 0;
	_intSize = sizeof ( short int );
	_numInts = 0;
	updateTimeout ( 25 );
}


AsciiToHetroCmd::~AsciiToHetroCmd()
{	
	// empty
}
	

void AsciiToHetroCmd::doCommand()
{
	if ( _done == True )
		return;

	int percent;
	char text[5], buf[BUFSIZE];
	int error = 0;

	_num[0] = 0;

	if ( !_once )
	{
		// can we open source for read?
		FileAccess *in = new FileAccess ( _srcFile, "r" );
		
		if ( in->errNum() != 0 )
		{
			char msg[BUFSIZE*2];
			
			error++;
			snprintf ( msg, sizeof ( msg ), "%s\nFile read error: %s", _srcFile, in->error() );
			msg [ sizeof ( msg ) - 1 ] = 0;
			messageDialogManager->post ( msg );
		}
		
		// can we open dst for write?
		FileAccess *out = new FileAccess ( _dstFile, "w" );
		
		if ( out->errNum() != 0 )
		{
			char msg[BUFSIZE*2];
			
			error++;
			snprintf ( msg, sizeof ( msg ), "%s\nFile write error: %s", _dstFile, out->error() );
			msg [ sizeof ( msg ) - 1 ] = 0;
			messageDialogManager->post ( msg );
		}
		
		if ( error )
		{
			delete in;
			delete out;
			_done = True;
			_error = error;
			return;
		}
		
		_in = in;
		_out = out;
		_once = 1;
	}

	if ( _in->filePos() < _in->fileSize() )
	{
		_in->readF ( buf, BUFSIZE );

		if ( buf[0] == ';' )
		{
			if ( strstr ( buf, "amplitude breakpoint set" ) != NULL )
			{
        			_num[0] = -1;
        			_out->writeF ( &_num[0], _intSize, 1 );
			}

			if ( strstr ( buf, "frequency breakpoint set" ) != NULL )
			{
        			_num[0] = -2;
        			_out->writeF ( &_num[0], _intSize, 1 );
			}

			if ( strstr ( buf, "end track" ) != NULL )
			{
				_num[0] = 32767;
				_out->writeF ( &_num[0], _intSize, 1 );
			}
		}
		else
		{
			if ( _numInts == 0 )
			{
				sscanf ( buf, "%d", &_num[0] );
				_out->writeF ( &_num[0], _intSize, 1 );
				_numInts++;
			}
			else
			{
				sscanf ( buf, "%d %d", &_num[0], &_num[1] );
				_out->writeF ( &_num, _intSize, 2 );
				_numInts++;
			}
		}

		percent = ( int ) ( ( float ) _in->filePos() / ( float ) _in->fileSize() * 100 );

		if ( _percentDone != percent )
		{
			_percentDone = percent;
			snprintf ( text, 5, "%d%%", _percentDone );
			updateMessage ( text );
		}
	}
	else
	{
		delete _in;
		delete _out;
		_done = True;
	}
}
