/*
	CsoundSampleSizeCmd.h - set csound number of samples (ksmps)

	Will Eighteen, 2000: will@opaline.demon.co.uk
*/

#ifndef CSOUNDSAMPLESIZECMD_H
#define CSOUNDSAMPLESIZECMD_H

#include "Cmd.h"

typedef void ( *enterCallback ) ( void *, char * );
typedef void ( *cancelCallback ) ( void * );


class LineEdit;

class CsoundSampleSizeCmd : public Cmd
{
	protected:
		virtual void doCommand();
		virtual void undoCommand();
		
	public:
		CsoundSampleSizeCmd ( const char *, int active = TRUE );
		virtual const char *const className() { return ( "CsoundSampleSizeCmd" ); }
		
	private:
		// note 'ok' is mapped to 'enter' by TextEdit
		static void enterCallback ( void *, char * );
		static void cancelCallback ( void * );
		void enter( unsigned int );
		LineEdit *_edit;
		Boolean _popupRealised;
};

#endif

/*
  Notes:
  
  UndoCommand is not implemeted here.
  
  The 'cancel' command is defaulted in TextEdit.
  
  'doCommand(0' should provide a resource to be displayed.
  'enter' should set a resource from text retrieved from the text widget.
*/
