/*
    SysCtrlPanel.cc

    Will Eighteen: will@opaline.demon.co.uk
*/

#include "SysCtrlPanel.h"
#include <ButtonInterface.h>

// #include Cmds.h...

#include <Xm/RowColumn.h>
#include "PlayCmd.h"
#include "StopCmd.h"


SysCtrlPanel::SysCtrlPanel ( const char *name, Widget parent ) : Interface ( name )
{
	CmdInterface *playBtn;
	CmdInterface *stopBtn;
	Cmd *playCmd;
	Cmd *stopCmd;
	
	_w = XtVaCreateManagedWidget ( _name, xmRowColumnWidgetClass, parent,
									XmNnumColumns, 1,
									XmNorientation, XmHORIZONTAL,
									NULL );
	
	installDestroyHandler();

	// instantiate obj for each cmd, set interactions
	playCmd = new PlayCmd ( "Play", TRUE );
	stopCmd = new StopCmd ( "Stop", FALSE );
	
	// dependencies
	playCmd->addToActivationList ( stopCmd );
	playCmd->addToDeactivationList ( playCmd );
	stopCmd->addToActivationList ( playCmd );
	stopCmd->addToDeactivationList ( stopCmd );

	// create user interface for cmds
	playBtn = new ButtonInterface ( _w, playCmd );
	stopBtn = new ButtonInterface ( _w, stopCmd );

	playBtn->manage();
	stopBtn->manage();
}
