/*
    WavToIntCmd.h - convert linear .wav format to integer

    Will Eighteen, 2000: will@opaline.demon.co.uk             
*/                                                                             

#ifndef WAVTOINTCMD_H
#define WAVTOINTCMD_H

#ifndef BREAK
#define BREAK
#include <BreakCmd.h>
#endif


#define BUFSIZE 1024


class Wave;
class FileAccess;


class WavToIntCmd : public BreakCmd
{
	public:
		WavToIntCmd ( char *, int, char *, char * );
		virtual ~WavToIntCmd();
		void setWaveDefaults ( long, short, short );
		char *source() { return _srcFile; };
		char *target() { return _dstFile; };
		int error() { return _error; }
		void offset ( int num ) { _offset = num; }
		void scale ( int num ) { _scale = num; }

	protected:
		void doCommand();
		
	private:
		long _blockLength, _dataLength;
		int _once, _percentDone, _error, _offset, _scale;
		char _srcFile[BUFSIZE];
		char _dstFile[BUFSIZE];
		FileAccess *_in;
		FileAccess *_out;
		long _samplesPerSec;
		short _bitsPerSample;
		short _channels;
};

#endif
