/*
 Confirm.cc - originally 'AskFirstCmd.cc'
 you could use QuestionDialogManager, but I don't like that wretched head.
 modified by Will 18, 2000; will@opaline.demon.co.uk.

 Adapted from
 Douglas A. Young, 'Object-oriented Programming with C++ and OSF/Motif'
 2nd ed., Prentice-Hall.
*/

#include "Confirm.h"
#include "MessageDialogManager.h"

#define DEFAULTQUESTION "Execute command?"


Confirm::Confirm ( const char *name, int active ) : Cmd ( name, active )
{
	_question = NULL;
	setQuestion ( DEFAULTQUESTION );
}


void Confirm::setQuestion ( const char *str )
{
	XtFree ( _question );
	_question = XtNewString ( str );
}

void Confirm::execute()
{
	messageDialogManager->post ( _question, ( void * ) this,
					  &Confirm::yesCallback );
}


void Confirm::yesCallback ( void *clientData )
{
	Confirm *obj = ( Confirm * ) clientData;
	obj->Cmd::execute();	// call base class execute() for command processing
}

/*
  Notes:
  
  The Confirm class overrides the virtual execute() member function implemented
  by Cmd. Instead of calling the doCommand() member function directly, this
  function uses the MessageDialogManager to post a dialog; '_qustion' is used for
  the string to be displayed in the dialog. The action supported is delayed until
  the question is answered.
  
  Selecting 'cancel' causes the dialog to be dismissed without execution of the
  command.
*/
